<template>
  <div id="app" class="sidebar-collapse">
    <headbar/>

    <sidebar/>

    <main id="app-content" role="main" @touchstart="onTouchStart" @touchend="onTouchEnd">
      <transition-page>
        <router-view :key="routeKey"/>
      </transition-page>

      <footer id="app-footer">
        <p class="text-muted" v-html="credits"></p>
      </footer>
    </main>

    <toasts/>
  </div>
</template>

<script>
import nProgress from 'nprogress'

import Headbar from '@/components/headbar'
import Sidebar from '@/components/sidebar'
import Toasts from '@/components/toasts'
import TransitionPage from '@/components/transition-page'
import { project, routeKey, sidebarToggler } from '@/mixins'

export default {
  name: 'app',

  mixins: [project, routeKey, sidebarToggler],

  components: {
    'headbar': Headbar,
    'sidebar': Sidebar,
    'toasts': Toasts,
    'transition-page': TransitionPage
  },

  watch: {
    '$route' (to, from) {
      // Update document title
      const route = to.matched.slice().reverse().find(r => r.meta.title)

      if (route) {
        document.title = [this.project.name, route.meta.title].join(' - ')
      }
    }
  },

  created () {
    if (sessionStorage.redirect) {
      const redirect = sessionStorage.redirect
      delete sessionStorage.redirect
      this.$router.push(redirect)
    }

    this.$router.beforeEach((to, from, next) => {
      if (to.name) {
        nProgress.start()
      }
      next()
    })

    this.$router.afterEach(() => {
      nProgress.done()
    })
  }
}
</script>

<style lang="scss">
@import '~@/styles/bootstrap';

.sidebar-collapse {
  transition: $transition-base;
  margin-top: $headbar-height;
  padding-left: $sidebar-width;
  overflow: hidden;

  @include media-breakpoint-down(sm) {
    padding-left: $sidebar-width-sm;
  }

  #app-content {
    transition: $transition-base;
  }

  &.show {
    #app-content {
      @include media-breakpoint-down(sm) {
        filter: blur(10px);
      }
    }

    #app-sidebar {
      width: 80%;

      @include media-breakpoint-up(sm) {
        width: $sidebar-width;
      }

      @include media-breakpoint-down(sm) {
        @include box-shadow($box-shadow);
        overflow: hidden;
      }
    }

    .sidebar-backdrop {
      opacity: 1;
    }
  }

  &:not(.show) {
    #app-content {
      @include media-breakpoint-down(sm) {
        filter: unset;
      }
    }

    #app-sidebar {
      width: 0;

      @include media-breakpoint-up(md) {
        width: $sidebar-width;
      }

      @include media-breakpoint-down(sm) {
        visibility: hidden;
      }

      .sidenav {
        margin-left: -$sidebar-width;

        @include media-breakpoint-up(md) {
          margin-left: 0;
        }
      }
    }

    .sidebar-backdrop {
      opacity: 0;
    }
  }
}

#app {
  background-color: $gray-100;

  &-content {
    width: 100%;
  }

  &-footer {
    padding-right: $page-gutter;
    padding-left: $page-gutter;
    height: $footer-height;
    border-top: $footer-border-width solid $border-color;

    p {
      margin: 0;
      font-size: 80%;
      line-height: $footer-height;
    }
  }
}
</style>
